package org.maachang.rimdb.table.array ;

import org.maachang.rimdb.ColumnType;
import org.maachang.rimdb.index.IndexUtil;
import org.maachang.rimdb.util.NList;

/**
 * Boolean配列.
 * 
 * @version 2014/07/07
 * @author  masahito suzuki
 * @since   rimdb-1.00
 */
public final class BooleanArray implements ColumnArray<Boolean> {
    private static final boolean[] IF = new boolean []{false,true} ;
    private int[] list ;
    private int[] nullList ;
    
    /**
     * コンストラクタ.
     * @param columns カラム群を設定します.
     */
    public BooleanArray( final Boolean[] columns ) {
        final NList nulls = new NList() ;
        final int len = columns.length ;
        int nLen = ( len >> 5 ) + ( ( len & 31 ) == 0 ? 0 : 1 ) ;
        final int[] n = new int[ nLen ] ;
        for( int i = 0 ; i < len ; i ++ ) {
            if( columns[ i ] == null ) {
                nulls.add( i ) ;
            }
            else if( columns[ i ] ) {
                n[ i >> 5 ] |= 1 << ( i & 31 ) ;
            }
        }
        list = n ;
        if( nulls.size() == 0 ) {
            nullList = null ;
        }
        else {
            nullList = nulls.sort().getArray() ;
        }
    }
    
    /**
     * カラムタイプを取得.
     * @return int カラムタイプが返却されます.
     */
    public final int getType() {
        return ColumnType.TYPE_BOOL ;
    }
    
    /**
     * 指定位置の情報を取得.
     * @param no 対象の項番を設定します.
     * @return Boolean 情報が返却されます.
     */
    public final Boolean get( final int no ) {
        if( nullList != null && IndexUtil.searchInt( nullList,no ) != -1 ) {
            return null ;
        }
        final int n = no & 31 ;
        return IF[ ( ( list[ no >> 5 ] & ( 1 << n ) ) >> n ) & 1 ] ;
    }
    
}
